package dcworms.schedframe.scheduling;

import java.util.LinkedList;

import schedframe.scheduling.ExecutionHistoryItem;
import schedframe.scheduling.ResourceItem;
import schedframe.scheduling.tasks.TaskInterface;
import schedframe.scheduling.tasks.phases.ExecutionProfile;
import schedframe.scheduling.tasks.requirements.ResourceParameterName;

public interface ExecTask extends TaskInterface<org.qcg.broker.schemas.resreqs.Task> {

	public boolean expectSpecificResource(ResourceParameterName resourceName);	
	public Object getExpectedSpecificResource(ResourceParameterName resourceName);
	
	public ExecutionProfile getExecutionProfile();
	
	public LinkedList<ResourceItem> getAllocatedResources();
    public String getSchedulerName();
	
	public LinkedList<ExecutionHistoryItem> getExecutionHistory();

}
