package simulator.stats.implementation;

import simulator.stats.DCwormsAccumulator;
import simulator.stats.implementation.out.StatsSerializer;

public class GSSAccumulatorsStats implements StatsInterface {

	public DCwormsAccumulator meanTotalOccupancy;
	public DCwormsAccumulator meanTotalLoad;
	public DCwormsAccumulator meanQueueLength;
	public DCwormsAccumulator meanEnergyUsage;
	public DCwormsAccumulator meanAirFlow;
	public DCwormsAccumulator meanTemperature;

	public DCwormsAccumulator meanTaskStartTime;
	public DCwormsAccumulator meanTaskCompletionTime;
	public DCwormsAccumulator meanTaskExecutionTime;
	public DCwormsAccumulator meanTaskWaitingTime;
	public DCwormsAccumulator meanTaskFlowTime;
	public DCwormsAccumulator lateness;
	public DCwormsAccumulator tardiness;
	public DCwormsAccumulator delayedTasks;
	public DCwormsAccumulator failedRequests;
	public DCwormsAccumulator makespan;

	private String[] headers = { "Resource name", "mean", "stdev", "variance",
			"minimum", "maximum", "sum", "count" };

	public GSSAccumulatorsStats() {
		meanTotalOccupancy = new DCwormsAccumulator();
		meanTotalLoad = new DCwormsAccumulator();
		meanQueueLength = new DCwormsAccumulator();
		meanEnergyUsage = new DCwormsAccumulator(); 
		meanAirFlow = new DCwormsAccumulator(); 
		meanTemperature = new DCwormsAccumulator(); 
		
		meanTaskStartTime = new DCwormsAccumulator();
		meanTaskCompletionTime = new DCwormsAccumulator();
		meanTaskExecutionTime = new DCwormsAccumulator();
		meanTaskWaitingTime = new DCwormsAccumulator();
		meanTaskFlowTime = new DCwormsAccumulator();
		lateness = new DCwormsAccumulator();
		tardiness = new DCwormsAccumulator();
		delayedTasks = new DCwormsAccumulator();
		failedRequests = new DCwormsAccumulator();
		makespan = new DCwormsAccumulator();
	}

	/*
	 * public static String getAcccumulatorHeader() {
	 * 
	 * String accumulatorSeparator = ";";
	 * 
	 * StringBuffer buffer = new StringBuffer(260);
	 * 
	 * buffer.append(header[0]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[1]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[2]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[3]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[4]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[5]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[6]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[7]); buffer.append(accumulatorSeparator);
	 * buffer.append(header[8]); buffer.append(accumulatorSeparator);
	 * 
	 * return buffer.toString(); }
	 */

	public Object serialize(StatsSerializer serializer) {
		return serializer.visit(this);
	}

	public String[] getHeaders() {
		return headers;
	}
}
